/////////////////////////////////////////////////////////////////
//Farbiges Feigenbaum-Diagramm für ungewöhnlichen Iterator
//(Die Farbe trägt keine zusätzliche Information, ist aber schön)
//////////////////////////////////////////////////////////////


//Initialisierung:
float rU = 0  ; 
float rO = 0;
float fU = 0; 
float fO = 0;
float lU = 0;
float lO =0;
//Zwischenspeicher:
float  rUNeu, rONeu, fUNeu, fONeu;


float lAlt, fAlt, fNeu, d; 
int w = 800; 
int h = 800; 
int NF, LF;
int i; //Iteration Feigenbaum
float flK; // r-Koordinate für beide
float fyK; //y-Koordinaten Feigenbaum
float NullAchseF;
boolean rKoordatenGezeichnet =false;
float r; //Parameter für logistisches Wachstum

float farbe =0;
///////////////////////////////////////////////////////////////////////////

void settings() {
  size(w, h);
} 
//Initialisierungen  
void setup() { 
  background(0); 
  colorMode(HSB,256,256,256);
  rU =12.6; 
  rO = 15.9;
  fU = -1; 
  fO = 1.3;
  NF= 1000; //Anzahl Iterationen Feigenbaum
  LF =700; //Feigenbaum ab hier gerechnet
  r = rU; //Start r
  d = (rO-rU)/4000; //Schrittweite
}

void draw() {

//Beschriftung und Hilfsgeraden werden weggelassen 
  if (r<rO){
     r = r +d;
     iteriereF(r); //Damit man die Entstehung beobachten kann immer nur für ein r
   }
}

/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 10-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() {  
  background(0);
  rKoordatenGezeichnet =false;
  rUNeu = map(mouseX, 0, w, rU, rO)-(rO-rU)/10;
  rONeu = map(mouseX, 0, w, rU, rO)+(rO-rU)/10;
  fUNeu = map(mouseY, 0, h, fO, fU)-(fO-fU)/10;
  fONeu = map(mouseY, 0, h, fO, fU)+(fO-fU)/10;
  rU = rUNeu; 
  rO = rONeu; 
  fU = fUNeu; 
  fO = fONeu;
  r = rU; 
  d = (rO-rU)/4000;
  NF = int(NF/(fO-fU));
  println("mousePressed startet");
    
}
//////////////////////////////////////////////////////////
//Feigenbaum-Iteration
////////////////////////////////////////////////////////
void iteriereF(float r) {  
  farbe = farbe + 0.05;
  stroke(color(farbe,255,255));
   strokeWeight(1);
  fAlt = 0.5; 
  flK = map(r, rU, rO, 0, w);      
  i=0;
  while (i <=NF) {
    fNeu = r/fAlt*sin(fAlt);
    if (i > LF && abs(fNeu) < 10) {
       fNeu = r/fAlt*sin(fAlt);
      fyK = map(fNeu, fU, fO, h, 0);   
      point(flK, fyK);    
    }
    fAlt = fNeu;
    i++;
  }
 
}